<?
/*
 chart.php
 
 Erstellt Chart-Grafiken als PNG
 Nutzt die GD-Library
 
 Ursprnglicher Code von www.phpbuilder.com
 Modifiziert und Angepasst fr b1gMail von B1G - www.b1g.info
*/

if (!function_exists('imagecreate')) {
	header("Content-type: image/png");
	readfile("staterror.png");
	exit;
}

$width = $_REQUEST[width];
$height = $_REQUEST[height];
$titel = $_REQUEST[titel];
$daten = $_REQUEST[daten];

$data = array();

$daten = explode("|", $daten);
for ($i=0; $i<=count($daten)-1; $i++) {
 $war = explode(";", $daten[$i]);
 $data[$war[0]] = $war[1];
}
  
$image = imagecreate($width+4, $height);  
$white = imagecolorallocate($image, 0xFF, 0xFF, 0xFF);  
$navy = imagecolorallocate($image, 0x33, 0x66, 0x99);  
$black = imagecolorallocate($image, 0x00, 0x00, 0x00);  
$gray = imagecolorallocate($image, 0xC0, 0xC0, 0xC0);  
$maxval = max($data);  
$nval = sizeof($data);  
$vmargin = 20;
$hmargin = 38;
$base = floor(($width - $hmargin) / $nval);
$ysize = $height - 2 * $vmargin;
$xsize = $nval * $base;
$titlefont = 3;  
$title = $titel;  
imagerectangle($image, 0, 0, $width+3, $height-1, $black);  
$txtsz = imagefontwidth($titlefont) * strlen($title);
$xpos = (int)($hmargin + ($xsize - $txtsz)/2);
$xpos = max(1, $xpos);
$ypos = 3;
imagestring($image, $titlefont, $xpos, $ypos, $title , $black);  
$labelfont = 2;  
$ngrid = 4; 
$dydat = $maxval / $ngrid;
$dypix = $ysize / ($ngrid + 1);

for ($i = 0; $i <= ($ngrid + 1); $i++) {  
    $ydat = (int)($i * $dydat);  
    $ypos = $vmargin + $ysize - (int)($i*$dypix);  
    $txtsz = imagefontwidth($labelfont) * strlen($ydat);
    $txtht = imagefontheight($labelfont);
    $xpos = (int)(($hmargin - $txtsz) / 2);  
    $xpos = max(1, $xpos);  
    imagestring($image, $labelfont, $xpos, $ypos - (int)($txtht/2), $ydat, $black);  
    if (!($i == 0) && !($i > $ngrid)) { 
        imageline($image, $hmargin - 3, $ypos, $hmargin + $xsize, $ypos, $gray);  
    } 
}  

$padding = 3;
@$yscale = $ysize / (($ngrid+1) * $dydat);

for ($i = 0; list($xval, $yval) = each($data); $i++) {  
    $ymax = $vmargin + $ysize;  
    $ymin = $ymax - (int)($yval*$yscale);  
    $xmax = $hmargin + ($i+1)*$base - $padding;  
    $xmin = $hmargin + $i*$base + $padding;  
    imagefilledrectangle($image, $xmin, $ymin, $xmax, $ymax, $navy);  
    $txtsz = imagefontwidth($labelfont) * strlen($xval);  
    $xpos = $xmin + (int)(($base - $txtsz) / 2);  
    $xpos = max($xmin, $xpos);  
    $ypos = $ymax + 3;
    imagestring($image, $labelfont, $xpos, $ypos, $xval, $black);  
}  

imagerectangle($image, $hmargin, $vmargin, $hmargin + $xsize, $vmargin + $ysize, $black);  
header("Content-type: image/png");
imagepng($image);
imagedestroy($image);  
?>